 
// Here we avoid loading the header multiple times
#ifndef TvGr_HEADER
#define TvGr_HEADER
// We need the Plasma Applet headers

#include <Plasma/Applet>
#include <Plasma/DataEngine>
#include <Plasma/Dialog>
#include <plasma/widgets/pushbutton.h>
#include <plasma/animator.h>
#include <kio/jobclasses.h>
#include <KMenu>

#include <QDateTime>
#include <QVector>
#include <QStringList>
#include <QTimer>
#include <QTextCodec>
#include <QFontMetrics>
#include <QPushButton>
#include <QGraphicsProxyWidget>


#include <KColorScheme>
#include <KSharedConfig>
#include "ui_configDialog.h"

 
class QSizeF;

 namespace Plasma
{
    class Svg;
};
 
 namespace Plasma
{
    class PushButton;
};
// Define our plasma Applet
class PlasmaTvGr : public Plasma::Applet
{
    Q_OBJECT
    public:
        // Basic Create/Destroy
        PlasmaTvGr(QObject *parent, const QVariantList &args);
        ~PlasmaTvGr();
	
        // The paintInterface procedure paints the applet to screen
        void paintInterface(QPainter *painter,
                const QStyleOptionGraphicsItem *option,
                const QRect& contentsRect);
	void init();
	void initConfig();
	void constraintsEvent(Plasma::Constraints constrains);
	void calculateSizes(void);
	void selectChannel(int i1);
	void initMenu();
	void execMenu();
	//DONE ADD UPDATE to MENU select
	//DONE Something is wrong with the last entry highlight.
	//DONE Animation problem.
	
	virtual void mousePressEvent ( QGraphicsSceneMouseEvent * event );
	virtual	void mouseDoubleClickEvent ( QGraphicsSceneMouseEvent * event );

public slots:
	void updateLists();
	void loopUpdate();
	void prevClicked();
	void nextClicked();
	void slotGotData(KJob *job);
        void showConfigurationInterface();
	void themeUpdated();
	void animationUpdate(qreal progress);



protected slots:
        void configAccepted(); 

    private:

	QStringList m_list1;//hour
	QStringList m_list2;//title
	QStringList m_list3;//station
	QStringList m_list4;//category
	QString m_webpage;
	QStringList m_chan1;//selected channel
	QStringList m_chan2;
	QStringList m_chan3;
	QStringList m_chan4;
	QVector<Plasma::Svg*> m_images;
	QDateTime m_date1,m_date2; //date of the last update
	KDialog *m_dialog;
	
	KJob *m_job;
	QTimer* m_timer; //the timer for update
	QTimer* m_loopTimer;
	bool m_httpOK; //if data get is ok
	Plasma::PushButton *m_buttonPrev;//next prev buttons
	Plasma::PushButton *m_buttonNext;
	QStringList chan; //channels' names
	QString     m_chanList; 
	//options
	Ui::configDialog ui;
	int m_loop; // seconds for loop channel , 0 for no loop
	int m_channelID; //channel ID
	int m_fontSize;
	QString m_channel; // channel name (not an option)
	int m_timeIndex;// this keeps the current program time for the selected channel
	KMenu* menu;
	//colors-design
	int m_pixmapUpdate;
	int m_animID;
	int m_fromConstraints;
	qreal m_animOpacity;
	QPixmap* m_oldPixmap;
	QPixmap* m_newPixmap;
	QColor m_colfg;
	QColor m_colselfg;
	QFont m_font;
	QSizeF n_size;
	QRectF m_textBox;
	int m_textH;
	int m_numOfLines;

	

	
};
 
// This is the command that links your applet to the .desktop file
K_EXPORT_PLASMA_APPLET(tvgr, PlasmaTvGr)
#endif
